#! /bin/bash

#######################################################################
#################           PARAMETROS             ####################
#######################################################################
#ip_ban="119.94.116.145"
#Le pasamos el primer parametro del script
ip_ban=$1


#######################################################################
######################     VARIABLES   CONEXION    ####################
#######################################################################
ip_servidor={ip_servidor}
usuario_servidor="{usuario}"
password_servidor="Contraseña"
BD_servidor="bd_log_ugit"
servidor_atacado=$(hostname -s)



#######################################################################
###########   FUNCION Comprobar si ya existe la IP    #################
#######################################################################
function verificaExiste () {
    export MYSQL_PWD=$3
    RESPUESTA=$(mysql $1 -u$2  -h$4 -s <<<"SELECT IP FROM tab_blacklist_ips WHERE IP = '$5'")
    if [[ $RESPUESTA ]]
    then
      #Existe
      true
    else
      #No existe
      false
    fi
}


#######################################################################
###########        FUNCION Guarda IP en BD            #################
#######################################################################
function guardaIP(){
  ##PARAMETROS
  #$1:$BD_servidor
  #$2:$usuario_servidor
  #$3:$password_servidor
  #$4:$ip_servidor
  #$5:$ip_ban
  #$6:$servidor_atacado
  Fecha_Hora=`date +"%Y-%m-%d %T"`
  servidor_atacado=$(hostname -s)
  freegeoip="DESCONOCIDO"
  ip="DESCONOCIDO"
  country_code="DESCONOCIDO"
  country_name="DESCONOCIDO"
  region_code="DESCONOCIDO"
  region_name="DESCONOCIDO"
  city="DESCONOCIDO"
  latitude="DESCONOCIDO"
  longitude="DESCONOCIDO"
  netname="DESCONOCIDO"
  organization="DESCONOCIDO"
  responsible="DESCONOCIDO"
  role="DESCONOCIDO"
  cidr="DESCONOCIDO"
  route="DESCONOCIDO"

  #######################################################################
  ################# P1:  Ejecutar consulta a Freegeoip   ##################
  #######################################################################
  #freegeoip=`curl -s --get http://poseidon.siua.ac.cr:8080/json/$ip_ban`
  freegeoip=`curl -s --get http://freegeoip.net/json/$5`

  ip=$(echo "$freegeoip" | jq -r '.ip')
  if [ ! -z "$ip" ]
  then
    ip=$ip
  else
    ip=$5
  fi
  country_code=$(echo "$freegeoip" | jq -r '.country_code')
  if [ ! -z "$country_code" ]
  then
    country_code=$country_code
  else
    country_code="VACIO"
  fi
  country_name=$(echo "$freegeoip" | jq -r '.country_name')
  if [ ! -z "$country_name" ]
  then
    country_name=$country_name
  else
    country_name="DESCONOCIDO"
  fi
  region_code=$(echo "$freegeoip" | jq -r '.region_code')
  if [ ! -z "$region_code" ]
  then
    region_code=$region_code
  else
    region_code="VACIO"
  fi
  region_name=$(echo "$freegeoip" | jq -r '.region_name')
  if [ ! -z "$region_name" ]
  then
    region_name=$region_name
  else
    region_name="DESCONOCIDO"
  fi
  city=$(echo "$freegeoip" | jq -r '.city')
  if [ ! -z "$city" ]
  then
    city=$city
  else
    city="DESCONOCIDO"
  fi
  latitude=$(echo "$freegeoip" | jq -r '.latitude')
  if [ ! -z "$latitude" ]
  then
    latitude=$latitude
  else
    latitude="10.019816"
  fi
  longitude=$(echo "$freegeoip" | jq -r '.longitude')
  if [ ! -z "$longitude" ]
  then
    longitude=$longitude
  else
    longitude="-84.197004"
  fi

#printf "******************************************\n"
#printf "*********** DATOS: FREEGEOIP     *********\n"
#printf "******************************************\n"
#printf "ip:${ip}\n"
#printf "country_code:${country_code}\n"
#printf "country_name:${country_name}\n"
#printf "region_code:${region_code}\n"
#printf "region_name:${region_name}\n"
#printf "city:${city}\n"
#printf "latitude:${latitude}\n"
#printf "longitude:${longitude}\n"


  #######################################################################
  #################  P2: Ejecutar consulta a ARIN       #################
  #######################################################################
  #netname
  netname=`whois $5 -h whois.arin.net | grep -i netname: | tail -n 1`
  netname=${netname#"NetName:        "}
  netname=${netname#"netname:        "}

  #organization
  organization=`whois $5 -h whois.arin.net | grep -i organization: | tail -n 1`
  organization=${organization#"Organization:   "}

  #responsible
  responsible=`whois $5 -h whois.arin.net | grep -i responsible: | tail -n 1`
  responsible=${responsible#"responsible: "}

  #role
  role=`whois $5 -h whois.arin.net | grep -i role: | tail -n 1`
  role=${role#"role:           "}

  #cidr
  cidr=`whois $5 -h whois.arin.net | grep -i cidr: | tail -n 1`
  cidr=${cidr#"CIDR:           "}

  #route
  route=`whois $5 -h whois.arin.net | grep -i route: | tail -n 1`
  route=${cidr#"route:          "}


#printf "******************************************\n"
#printf "***********     DATOS: WHOIS     *********\n"
#printf "******************************************\n"
#printf "netname:${netname}\n"
#printf "organization:${organization}\n"
#printf "responsible:${responsible}\n"
#printf "role:${role}\n"
#printf "cidr:${cidr}\n"
#printf "route:${route}\n"


  ##########################################################################
  #####################  P3:OBTENER NOMBRE       ###########################
  ##########################################################################
  if [ ! -z "$netname" ]
  then
  	nombre=$netname
  else
  	if [ ! -z "$organization" ]
  	then
  		nombre=$organization
  	else
  		if [ ! -z "$responsible" ]
  		then
  			nombre=$responsible
  		else
  			if [ ! -z "$role" ]
  			then
  				nombre=$role
  			else
  				nombre="No existe"
  			fi
  		fi
  	fi
  fi

  ##########################################################################
  ##################### P4: OBTENER ORGANIZACION   #########################
  ##########################################################################
  if [ ! -z "$organization" ]
  then
  	organizacion=$organization
  else
  	if [ ! -z "$netname" ]
  	then
  		organizacion=$netname
  	else
  		if [ ! -z "$responsible" ]
  		then
  			organizacion=$responsible
  		else
  			if [ ! -z "$role" ]
  			then
  				organizacion=$role
  			else
  				organizacion="No existe"
  			fi
  		fi
  	fi
  fi

  ##########################################################################
  #####################     P5: OBTENER CIDR       #########################
  ##########################################################################
  if [ ! -z "$cidr" ]
  then
  	cidr=$cidr
  else
  	if [ ! -z "$route" ]
  	then
  		cidr=$route
  	else
  		cidr=""
  	fi
  fi



#printf "******************************************\n"
#printf "***********     DATOS: TRABAJADOS  *******\n"
#printf "******************************************\n"
#printf "nombre:${nombre}\n"
#printf "organizacion:${organizacion}\n"
#printf "cidr:${cidr}\n"


  ##########################################################################
  #####################  P6: Inserta en MYSQL      #########################
  ##########################################################################
  export MYSQL_PWD=$3
  mysql -u$2 -h$4 -e "
  insert into tab_blacklist_ips
    (
      IP,
      Nombre_Red,
      Organizacion,
      Codigo_Pais,
      Nombre_Pais,
      Codigo_Region,
      Nombre_Region,
      Cuidad,
      CIDR,
      Latitud,
      Longitud,
      Fecha_Hora,
      Servidor
    ) values(
      '$ip',
      '$nombre',
      '$organizacion',
      '$country_code',
      '$country_name',
      '$region_code',
      '$region_name',
      '$city',
      '$cidr',
      '$latitude',
      '$longitude',
      '$Fecha_Hora',
      '$servidor_atacado'
    );" $1 &> /dev/interuniversitariadealajuela

	#######################################################################
	##############           AGREGAR A UFW             ####################
	#######################################################################
	#Obtenemos el archivo
	readonly ufw_file=/etc/ufw/user.rules
	      #######################################################################
	      ##############       RECORREMOS LAS IPS            ####################
	      #######################################################################
	      printf "\n"
	      printf "*****************************************\n"
	      printf "AGREGANDO A LA UFW... \n"
	      printf "*****************************************\n"

	      sed -i '
		 /### RULES ###/ {
		 n
		 a\### tuple ### deny any any 0.0.0.0/0 any '$ip' in
		 a\-A ufw-user-input -s '$ip' -j DROP\n

	       }' $ufw_file
		printf "$ip\t\t INCLUIDA CON EXITO!\n"
		 printf "\n"
	      printf "*****************************************\n"
	      printf "FIN UFW... \n"
	      printf "*****************************************\n"
	
	true



	#######################################################################
	##############           AGREGAR A UFW             ####################
	#######################################################################
	#Obtenemos el archivo
	readonly ufw_file=/etc/ufw/user.rules
	#######################################################################
	##############       RECORREMOS LAS IPS            ####################
	#######################################################################
	printf "\n"
	printf "*****************************************\n"
  printf "AGREGANDO A LA UFW... \n"
	printf "*****************************************\n"

	sed -i '
		 /### RULES ###/ {
		 n
		 a\### tuple ### deny any any 0.0.0.0/0 any '$ip' in
		 a\-A ufw-user-input -s '$ip' -j DROP\n

	       }' $ufw_file
	printf "$ip\t\t INCLUIDA CON EXITO!\n"
	printf "\n"
	printf "*****************************************\n"
	printf "FIN UFW... \n"
	printf "*****************************************\n"

  true
}


#######################################################################
############  PASO1: Comprobamos si ya existe en la BD ################
#######################################################################
printf "\n"
printf "*********************************************\n"
printf "RESULTADO de la IP: $ip_ban\n"
printf "*********************************************\n"
if verificaExiste $BD_servidor $usuario_servidor $password_servidor $ip_servidor $ip_ban
then
    #Salimos del script
    printf "La IP YA EXISTE en la BD, salimos!!\n\n"
    exit
else
    #Si no existe mandela a guardar
    if guardaIP $BD_servidor $usuario_servidor $password_servidor $ip_servidor $ip_ban $servidor_atacado
    then
      printf "La IP ha sido INCLUIDA correctamente!!\n\n"


      correo="<!DOCTYPE>"
      correo="$correo<html>"
      correo="$correo<head>"
      correo="$correo<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>"
      correo="$correo<meta name='viewport' content='width=device-width, initial-scale=1'>"
      correo="$correo<title>[BD/F/$servidor_atacado/$ip_ban] </title>"
      correo="$correo<style type='text/css'>"
      correo="$correo table, th, td {border: 1px solid black; padding:5px}a{text-decoration: none;}.link:hover {text-decoration: none !important;}@media screen and (min-width: 650px) {.des-pt50 {padding-top: 50px !important;}.des-pb50 {padding-bottom: 50px !important;}.des-mauto {margin: 0px !important;}.des-pb0 {padding-bottom: 0px !important;}.td, .tfoot, .thead {display: table-cell !important;}.table {display: table;	width: 100%;}}"
      correo="$correo</style>"
      correo="$correo</head>"
      correo="$correo<body style='margin:0;padding:0;background: #F8F8F8;' id='body'>"
      correo="$correo<div class='tac pt10 pb10 pl10 pr10' style='padding-top:10px;padding-bottom:10px;padding-right:10px;padding-left:10px;text-align:center;background: #015289;'>"
      correo="$correo<div class='table' style='max-width: 600px; margin:0 auto;'>"
      correo="$correo<div class='td w50p vam' style='vertical-align:middle;'>"
      correo="$correo<img alt='SIUA' border='0' class='pb10 des-mauto des-pb0' src='https://siua.ac.cr/img/logo.png' style='display:block;border:0;padding-bottom:10px;margin:0 auto; display: block; color: #ffffff; ' width='125'>"
      correo="$correo</div>"
      correo="$correo<div class='td w50p vam des-tar' style='vertical-align:middle;'>"
      correo="$correo<p class='white' style='margin:0;font-size:16px;font-family: Helvetica, Arial, sans-serif;color:#ffffff;'>"
      correo="$correo Unidad de Gestión e Innnovación Tecnológica"
      correo="$correo</p>"
      correo="$correo</div>"
      correo="$correo</div>"
      correo="$correo</div>"
      correo="$correo<div class='frame' style='background:#F8F8F8;'>"
      correo="$correo<div class='pl15 pr15 pt35 des-pt50 pb25 des-pb50' style='padding-right:15px;padding-left:15px;padding-bottom:25px;padding-top:35px;'>"
      correo="$correo<div class='wrapper pt35 pb35 pl35 pr35 box' style='padding-top:35px;padding-bottom:35px;padding-right:35px;padding-left:35px;max-width:600px;margin:0 auto;text-align:center;mso-element-frame-width:800px;mso-element:para-border-div;mso-element-left:center;mso-element-wrap:no-wrap-beside;mso-padding-top-alt:50px;background:#ffffff;border-radius:10px;'>"
      correo="$correo<h2 class='fsz30 lh36 bold pt25 pb15 mso-mb15' style='font-family:Helvetica, Arial, sans-serif;margin:0;padding-bottom:15px;padding-top:25px;color:#353a3e;font-family:Helvetica, Arial, sans-serif;font-weight:bold;font-size:30px;line-height:36px;mso-margin-bottom-alt:15px;'>"
      correo="$correo IPs Incluidas en BD y UFW"
      correo="$correo</h2>"
      correo="$correo<p class='fsz16 lh24 mso-mb25' style='margin:0;color:#777777;font-family:Helvetica, Arial, sans-serif;font-size:16px;line-height:24px;mso-margin-bottom-alt:25px;'>"
      correo="$correo<table style='width:100%; background-color:#FFFFFF;border-collapse: collapse;align:center'>"
      correo="$correo<tr style='text-align:center; background-color:#015289;color:#ffffff;'>"
      correo="$correo<td>IP</td>"
      correo="$correo<td>Fecha y Hora</td>"
      correo="$correo<td>Organización</td>"
      correo="$correo</tr>"
      correo="$correo<tr style='text-align:center; background-color:#FFFFFF;color:#333333;'>"
      correo="$correo<td>$ip_ban</td>"
      correo="$correo<td>$Fecha_Hora</td>"
      correo="$correo<td>$organizacion</td>"
      correo="$correo</tr>"
      correo="$correo</table>"
      correo="$correo</p>"
      correo="$correo</div>"
      correo="$correo</div>"
      correo="$correo</div>"
      correo="$correo</body>"
      correo="$correo</html>"





      echo $correo | mail \
      -a "From: interuniversitariadealajuela@gmail.com" \
      -a "MIME-Version: 1.0" \
      -a "Content-Type: text/html" \
      -s "[BD/F/$servidor_atacado/$ip_ban]" \
      interuniversitariadealajuela@gmail.com

      #bash /etc/fail2ban/verifica_ips_bd_PROXMOX.sh






      exit
    else
      printf "La IP NO se agrego correctamente por favor verifiquela!!\n\n"
      echo "Problema al agregar IP: $ip_ban" | mail -s "[ERROR_AB_$servidor_atacado]: $ip_ban" interuniversitariadealajuela@gmail.com
      exit
    fi

fi
